# Microb Technology, Eirbot, Droids-corp 2005 - Zer0
# Makefile for projects
# 
# Inspired by the WinAVR Sample makefile written by Eric
# B. Weddington, Jrg Wunsch, et al.
#

# default HOST is avr
ifeq ($(H),)
HOST=avr
else
HOST=host
endif

OBJ = $(addprefix compiler_files/,$(SRC:.c=.$(HOST).o) $(ASRC:.S=.$(HOST).o))
LST = $(OBJ:.o=.lst)
DEPS = $(addprefix compiler_files/,$(SRC:.c=.$(HOST).d))

# Default target.
all: compiler_files/$(TARGET).$(HOST).a

# Module library file
compiler_files/$(TARGET).$(HOST).a: $(OBJ)
	${AR} rs $@ $(OBJ)

# Automatically generate C source code dependencies. 
compiler_files/%.$(HOST).d : %.c
	@echo Generating $@
	@set -e; rm -f $@; \
	$(CC) -M $(CFLAGS) $< > $@.$$$$; \
	sed 's,\($*\)\.o[ :]*,compiler_files/\1.$(HOST).o $@ : ,g' < $@.$$$$ > $@; \
	rm -f $@.$$$$

compiler_files/%.$(HOST).o : %.c
	@echo Compiling $< 
	$(CC) $(CFLAGS) $< -c -o $@

# Compile: create assembler files from C source files.
compiler_files/%.$(HOST).s : %.c
	$(CC) -S $(CFLAGS) $< -o $@

# Assemble: create object files from assembler source files.
compiler_files/%.$(HOST).o : %.S
	$(CC) -c -Wa,-adhlns=$(@:.o=.lst) $(MODULES_ASFLAGS) $< -o $@


# Remove the '-' if you want to see the dependency files generated.
ifeq (,$(findstring clean,$(MAKECMDGOALS)))
-include $(DEPS)
endif

# Clean all objects 
clean:
	$(REMOVE) compiler_files/$(TARGET).$(HOST).a
	$(REMOVE) $(OBJ) 
	$(REMOVE) $(LST)

depclean:
	$(REMOVE) $(DEPS)

# Listing of phony targets.
.PHONY : all clean deps
