/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: scheduler.c,v 1.8 2005-10-29 17:30:36 zer0 Exp $
 *
 */

#include <avr/signal.h>

#include <utils.h>

#include <scheduler.h>
#include <scheduler_archs.h>

#include "scheduler_common.h"


extern void scheduler_common_init(void);


void scheduler_init(void)
{
	/* activation of corresponding interrupt */
	sbi(TIMSK, TOIE0); 
	/* reset TCNT0, facultatif */
	TCNT0 = 0; 
	   
	scheduler_common_init();
	
	TCCR0 = SCHEDULER_CK; 
}


/* takes about (10 + 3 * size(table)) microsec at 8Mhz 
 * the measure is quite old, so take it with care */
INTERRUPT(SIG_OVERFLOW0) /* other ints allowed */
{
  scheduler_common_interrupt();
}
