/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: scheduler_archs.h,v 1.4 2006-02-05 23:58:06 zer0 Exp $
 *
 */

/* Eirbot - Microb Technology 2005 - Zer0
 * Register configuration for scheduler module
 */

#ifndef SCHEDULER_ARCHS_H
#define SCHEDULER_ARCHS_H

#include <scheduler_config.h>

/******************************/

#if defined(__AVR_AT90S2313__) || defined(__AVR_AT90S8515__)
#if (SCHEDULER_CLOCK_PRESCALER == 1)
#define SCHEDULER_CK    1 
#elif (SCHEDULER_CLOCK_PRESCALER == 8)
#define SCHEDULER_CK    2
#elif (SCHEDULER_CLOCK_PRESCALER == 64)  
#define SCHEDULER_CK 3 
#elif (SCHEDULER_CLOCK_PRESCALER == 256) 
#define SCHEDULER_CK 4 
#elif (SCHEDULER_CLOCK_PRESCALER == 1024)
#define SCHEDULER_CK 5 
#else
#error Invalid Prescaler value (SCHEDULER_CLOCK_PRESCALER). Allowed values 1, 8, 64, 256, 1024
#endif


/******************************/

#elif defined (__AVR_ATmega128__) 
#if (SCHEDULER_CLOCK_PRESCALER == 1)   
#define SCHEDULER_CK 1 
#elif (SCHEDULER_CLOCK_PRESCALER == 8)   
#define SCHEDULER_CK 2
#elif (SCHEDULER_CLOCK_PRESCALER == 32)  
#define SCHEDULER_CK 3 
#elif (SCHEDULER_CLOCK_PRESCALER == 64)  
#define SCHEDULER_CK 4 
#elif (SCHEDULER_CLOCK_PRESCALER == 128) 
#define SCHEDULER_CK 5 
#elif (SCHEDULER_CLOCK_PRESCALER == 256) 
#define SCHEDULER_CK 6 
#elif (SCHEDULER_CLOCK_PRESCALER == 1024)
#define SCHEDULER_CK 7 
#else
#error Invalid Prescaler value (SCHEDULER_CLOCK_PRESCALER). Allowed values 1, 8, 32, 64, 128, 256, 1024
#endif

/******************************/

#elif defined (__AVR_ATmega32__) 
#if (SCHEDULER_CLOCK_PRESCALER == 1)   
#define SCHEDULER_CK 1 
#elif (SCHEDULER_CLOCK_PRESCALER == 8)   
#define SCHEDULER_CK 2
#elif (SCHEDULER_CLOCK_PRESCALER == 64)  
#define SCHEDULER_CK 3
#elif (SCHEDULER_CLOCK_PRESCALER == 256) 
#define SCHEDULER_CK 4
#elif (SCHEDULER_CLOCK_PRESCALER == 1024)
#define SCHEDULER_CK 5
#else
#error Invalid Prescaler value (SCHEDULER_CLOCK_PRESCALER). Allowed values 1, 8, 64, 256, 1024
#endif

/******************************/


// #elif defined (another_avr)

// add defs here


#else //avr type
#error This type of AVR is not supported by the SCHEDULER Module. \
       Please Check the scheduler_archs.h file \
       to resolve the problem, it should be quite easy.
#endif // avr type


#endif // SCHEDULER_ARCHS_H
