/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: scheduler_host.c,v 1.5 2005-10-29 17:30:36 zer0 Exp $
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>

#include <utils.h>

#include <scheduler.h>

#include "scheduler_common.h"


extern void scheduler_common_init(void);

int response[2];


void intr(int val)
{
  char dummy=0;

  scheduler_common_interrupt();
  write(response[1], (void *)&dummy, 1);
}

void scheduler_init(void)
{
  int r,p,a,i;
  char dummy;

  pipe(response);

  if((p=fork()))
    {
      // papa
	    while(1) {
		    printf("ready>\n");
		    scanf("%d",&a);
		    for(i=0 ; i<a ; i++) {
			    r=kill(p,SIGUSR1);
			    read(response[0], &dummy, 1);
			    usleep(1000); 
		    }
	    }
    }
  else {
	  // fiston
	  signal(SIGUSR1,intr);
	  scheduler_common_init();
  }
}

