/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: main.c,v 1.8 2005-10-29 17:30:36 zer0 Exp $
 *
 */

#include <scheduler.h>
#include <wait.h>
#include <stdio.h>

u08 event_id;

#ifdef HOST_VERSION
#undef sbi
#undef cbi
#define sbi(port,bit) printf("%s %d ON\n",#port,bit)
#define cbi(port,bit) printf("%s %d OFF\n",#port,bit)
#endif

void f1(void * nothing)
{
  static u08 x=0;
  
  if(x)
    sbi(PORTE,2);
  else
    cbi(PORTE,2);

    x=!x;
}

void f2(void * nothing)
{
  static u08 x=0;
  
  if(x)
    sbi(PORTE,3);
  else
    cbi(PORTE,3);

    x=!x;
}

void f3(void * nothing)
{
  static u08 x=0;
  
  if(x)
    sbi(PORTB,3);
  else
    cbi(PORTB,3);
  
  wait_ms(500);
  x=!x;
}

void supp(void * nothing)
{
  scheduler_del_event(event_id);
}

int main(void)
{
#ifndef HOST_VERSION
  DDRB=0x18;
  DDRE=0x0C;
#endif

  scheduler_init();

  event_id = scheduler_add_periodical_event_priority(f1, NULL, 50000l/SCHEDULER_UNIT, 200);
  scheduler_add_periodical_event_priority(f2, NULL, 50000l/SCHEDULER_UNIT, 100);
  scheduler_add_periodical_event(f3, NULL, 1000000l/SCHEDULER_UNIT);

  //  scheduler_add_single_event(supp,65);

#ifndef HOST_VERSION
  sei();
#endif

  while(1);
  return 0;
}


