/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: irq_lock_macros.c,v 1.2 2006-02-05 23:58:06 zer0 Exp $
 *
 */

#include <utils.h>

#ifdef USE_MICROB_IRQ
volatile u08 intr_cpt = 0;

/**
 * lock irq
 * Provided as a function, it is code-space optimized, instead of speed.
 * It can be used in init functions where we don't need speed.
 */
void irq_lock(void)
{
	IRQ_LOCK();
}
/**
 * unlock irq
 * Provided as a function, it is code-space optimized, instead of speed.
 * It can be used in init functions where we don't need speed.
 */
void irq_unlock(void)
{
	IRQ_UNLOCK();
}

#endif /* USE_MICROB_IRQ */

