/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: utils.c,v 1.15 2006-02-05 23:58:06 zer0 Exp $
 *
 */

#include <utils.h>

/* only compile for AVR */
#ifndef HOST_VERSION

/**
 * reads a 32 bits value at address addr
 */
u32 eeprom_r32(u32 * addr)
{
  u32 out;
  eeprom_read_block(&out, addr, 4);
  return(out);
}

/**
 * reads a 24 bits value at address addr
 */
u32 eeprom_r24(u32 * addr)
{
  u32 out=0;
  eeprom_read_block(&out /*+1*/, addr, 3);
  return(out);
}
#endif /* not HOST_VERSION */


