/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: utils_types.h,v 1.2 2006-02-05 23:58:07 zer0 Exp $
 *
 */

#ifndef _UTILS_TYPES_H_
#define _UTILS_TYPES_H_

/* explicit types u = unsigned, s = signed  */
typedef unsigned char        u08;
#define U08_MIN 0x00
#define U08_MAX 0xFF

typedef unsigned short       u16;
#define U16_MIN 0x0000
#define U16_MAX 0xFFFF

typedef unsigned long        u32;
#define U32_MIN 0x00000000
#define U32_MAX 0xFFFFFFFF

/* XXX to test */
typedef unsigned long long   u64;
#define U64_MIN 0x0000000000000000
#define U64_MAX 0xFFFFFFFFFFFFFFFF

typedef signed char          s08;
#define S08_MIN 0x80
#define S08_MAX 0x7F

typedef signed short         s16;
#define S16_MIN 0x8000
#define S16_MAX 0x7FFF

typedef signed long          s32;
#define S32_MIN 0x80000000
#define S32_MAX 0x7FFFFFFF

/* XXX to test */
typedef signed long long     s64;
#define S64_MIN 0x8000000000000000
#define S64_MAX 0x7FFFFFFFFFFFFFFF

#endif /* _UTILS_TYPES_H_ */
