/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2005)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: quadramp.h,v 1.2 2006-02-05 23:58:07 zer0 Exp $
 *
 */

#ifndef _QUADRAMP_H_
#define _QUADRAMP_H_

#include <utils.h>

struct quadramp_filter
{
    u32 var_2nd_ord_pos;
    u32 var_2nd_ord_neg;
    u32 var_1st_ord_pos;
    u32 var_1st_ord_neg;

    s32 previous_var;
    s32 previous_out;
};

/** Initialization of the filter */
inline void quadramp_init(struct quadramp_filter * r);

inline void quadramp_set_2nd_order_vars(struct quadramp_filter * r, u32 var_2nd_ord_pos, u32 var_2nd_ord_neg);
inline void quadramp_set_1st_order_vars(struct quadramp_filter * r, u32 var_1st_ord_pos, u32 var_1st_ord_neg);

/**
 * Process the ramp
 * 
 * \param data should be a (struct quadramp_filter *) pointer
 * \param in is the input of the filter
 */
s32 quadramp_do_filter(void * data, s32 in);

#endif
