/*  
 *  Copyright Droids Corporation, Microb Technology, Eirbot (2006)
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Revision : $Id: multiservo.h,v 1.2 2006-02-21 23:05:18 zer0 Exp $
 *
 */

#ifndef _MULTISERVO__H_
#define _MULTISERVO__H_

#include <utils.h>
#include <multiservo_config.h>


struct multiservo_element {
	volatile u08 * port;
	u08 bitnum;
	u16 value;
};

struct multiservo {
	u32 time_sum;
	u16 current_multiservo;
	s08 id_prev;
	struct multiservo_element elts[MULTISERVO_NB_MAX];
};

extern struct multiservo g_multiservo;



void multiservo_init(void);

s08 multiservo_add(volatile u08 * port, u08 bitnum);

void multiservo_del(s08 id);

void multiservo_set(s08 id, u16 val);


#endif
