#include <utils.h>
#include <adc_config.h>
#include <avr/io.h>
#include <adc_archs.h>
#include <adc.h>

void adc_init(void)
{
#ifdef ADC_POWER_REDUCTION_PRR
	cbi(PRR,0);
#endif //ADC_POWER_REDUCTION_PRR
	ADMUX = ADC_REF;
	// for instance, ADLAR is set to 0 in all case.
	ADCSRA |= 0x80; // 1-------
	ADCSRA &= 0xD7; // --0-0---
	/* ADcENable
	 * ADcAutoTriggerEnable, disable.
	 * ADcInteruptionEnable, disable.
	 */
	
	return;
}
u16 adc_get_value(u08 i)
{
	volatile u16 return_value;
	ADMUX = ADC_REF | i;
	sbi(ADCSRA,6);
	while(!(ADCSRA & 0x40)); // !(--1-----)
	{
		nop();
	}
	return_value = ((u16) ADCH << 8) | (u16) ADCL;
	return return_value;
}
#ifdef USE_ADC_SHUTDOWN
void adc_shutdown(void)
{
	ADCSRA &= 0x57; // 0-0-0---
	/* ADcENable - > desable
	* ADcAutoTriggerEnable, disable.
	* ADcInteruptionEnable, disable.
	*/
#ifdef ADC_POWER_REDUCTION_PRR
	sbi(PRR,0);
#endif //ADC_POWER_REDUCTION_PRR
	return;
}
#endif // USE_ADC_INIBIT
