#ifndef _ADC_ARCHS_
#	define _ADC_ARCHS_


	// ATMEGA128 ////////////////////////////////////////
#	if defined (__AVR_ATmega128__)

	// For instance, this mux code seem to be standard
#	define ADC0_MUX_CODE 0x00
#	define ADC1_MUX_CODE 0x01
#	define ADC2_MUX_CODE 0x02
#	define ADC3_MUX_CODE 0x03
#	define ADC4_MUX_CODE 0x04
#	define ADC5_MUX_CODE 0x05
#	define ADC6_MUX_CODE 0x06
#	define ADC7_MUX_CODE 0x07
	// Here is the not standard mux code
#	define ADC0_0x10_MUX_CODE 0x08 
#	define ADC1_0x10_MUX_CODE 0x09
#	define ADC0_0x200_MUX_CODE 0x0A
#	define ADC1_0x200_MUX_CODE 0x0B
#	define ADC2_2x10_MUX_CODE 0x0C
#	define ADC3_2x10_MUX_CODE 0x0D
#	define ADC2_2x200_MUX_CODE 0x0E
#	define ADC3_2x200_MUX_CODE 0x0F
#	define ADC0_1x1_MUX_CODE 0x10
#	define ADC1_1x1_MUX_CODE 0x11
#	define ADC2_1x1_MUX_CODE 0x12
#	define ADC3_1x1_MUX_CODE 0x13
#	define ADC4_1x1_MUX_CODE 0x14
#	define ADC5_1x1_MUX_CODE 0x15
#	define ADC6_1x1_MUX_CODE 0x16
#	define ADC7_1x1_MUX_CODE 0x17
#	define ADC0_2x1_MUX_CODE 0x18
#	define ADC1_2x1_MUX_CODE 0x19
#	define ADC2_2x1_MUX_CODE 0x1A
#	define ADC3_2x1_MUX_CODE 0x1B
#	define ADC4_2x1_MUX_CODE 0x1C
#	define ADC5_2x1_MUX_CODE 0x1D
#	define ADCVBG_MUX_CODE 0x1E
#	define ADCGND_MUX_CODE 0x1F




	// ATMEGA32 ////////////////////////////////////////
#	elif defined (__AVR_ATmega32__) || defined (__AVR_ATmega323__)

	// For instance, this mux code seem to be standard
#	define ADC0_MUX_CODE 0x00
#	define ADC1_MUX_CODE 0x01
#	define ADC2_MUX_CODE 0x02
#	define ADC3_MUX_CODE 0x03
#	define ADC4_MUX_CODE 0x04
#	define ADC5_MUX_CODE 0x05
#	define ADC6_MUX_CODE 0x06
#	define ADC7_MUX_CODE 0x07
	// Here is the not standard mux code
#	define ADC0_0x10_MUX_CODE 0x08 
#	define ADC1_0x10_MUX_CODE 0x09
#	define ADC0_0x200_MUX_CODE 0x0A
#	define ADC1_0x200_MUX_CODE 0x0B
#	define ADC2_2x10_MUX_CODE 0x0C
#	define ADC3_2x10_MUX_CODE 0x0D
#	define ADC2_2x200_MUX_CODE 0x0E
#	define ADC3_2x200_MUX_CODE 0x0F
#	define ADC0_1x1_MUX_CODE 0x10
#	define ADC1_1x1_MUX_CODE 0x11
#	define ADC2_1x1_MUX_CODE 0x12
#	define ADC3_1x1_MUX_CODE 0x13
#	define ADC4_1x1_MUX_CODE 0x14
#	define ADC5_1x1_MUX_CODE 0x15
#	define ADC6_1x1_MUX_CODE 0x16
#	define ADC7_1x1_MUX_CODE 0x17
#	define ADC0_2x1_MUX_CODE 0x18
#	define ADC1_2x1_MUX_CODE 0x19
#	define ADC2_2x1_MUX_CODE 0x1A
#	define ADC3_2x1_MUX_CODE 0x1B
#	define ADC4_2x1_MUX_CODE 0x1C
#	define ADC5_2x1_MUX_CODE 0x1D
#	define ADCVBG_MUX_CODE 0x1E
#	define ADCGND_MUX_CODE 0x1F



	// ATMEGAx8 ////////////////////////////////////////
#	elif defined (__AVR_ATmega48__) || defined (__AVR_ATmega88__) || defined (__AVR_ATmega168__)


	// For instance, this mux code seem to be standard
#	define ADC0_MUX_CODE 0x00
#	define ADC1_MUX_CODE 0x01
#	define ADC2_MUX_CODE 0x02
#	define ADC3_MUX_CODE 0x03
#	define ADC4_MUX_CODE 0x04
#	define ADC5_MUX_CODE 0x05
#	define ADC6_MUX_CODE 0x06
#	define ADC7_MUX_CODE 0x07

	// Here is the not standard mux code
#	define ADCVBG_MUX_CODE 0x0E
#	define ADCGND_MUX_CODE 0x0F


#	ifdef ADC_POWER_REDUCTION
#		define ADC_POWER_REDUCTION_PRR
#	endif
#	else // other AVR type
#		error "the AVR ADC archs of your AVR is not implemented yet. Please update the adc_archs.h"
#	endif // AVR type
#endif // _ADC_ARCHS_
