#include <avr/io.h>
#include <wait.h>
#include <uart.h>

#include<stdio.h>

volatile int nb_tx_bytes=0;

/* done in interrupt */
void recv_char(char c)
{
  printf("%d\r\n",nb_tx_bytes);
}

void xmit_char(char c)
{
  nb_tx_bytes++;
}



int main(void)
{
  DDRE=0x0C;
  struct uart_config u;
  int i=0;

  sbi(PORTE, 2);
  uart_init();
  fdevopen(uart0_send, uart0_recv, 0);
  uart0_register_rx_event(recv_char);
  uart0_register_tx_event(xmit_char);
  
  sei();

  uart0_getconf(&u);

  while(1) {
    printf("titi%d\r\n",i++);
    sbi(PORTE, 2);
    wait_ms(1000);

    printf("%d %d %d %d %d / %d %ld\r\n", 
	   u.enabled, u.intr_enabled, u.use_double_speed,
	   u.parity, u.stop_bits,
	   u.nbits, u.baudrate);
    cbi(PORTE, 2);
    wait_ms(1000);
  }

  return 0;
}
